#version 400
#define WANGHASH
//#version 120
//#define OLD_FRAG

#include "MathUtils.frag"
#include "newIQPath.frag"
//#include "iqPath_Light.frag"
//#include "Sky-PathTracer.frag"


#group Menger
uniform int Iterations;  slider[0,8,100]
uniform float Scale; slider[0.00,3.0,4.00]
uniform vec3 Offset; slider[(0,0,0),(1,1,1),(3,3,3)]
uniform bool Use_Floor; checkbox[false]
uniform int ColorIterations;  slider[0,2,100]

float DE(vec3 z)
{
	float p = z.z;
	float r;
	int n = 0;
	z = abs(z);
	if (z.x<z.y){ z.xy = z.yx;}
	if (z.x<z.z){ z.xz = z.zx;}
	if (z.y<z.z){ z.yz = z.zy;}
	if (z.z<1./3.){ z.z -=2.*( z.z-1./3.);}
	while (n < Iterations && dot(z,z)<100.0) {
		z=Scale* (z-Offset)+Offset;
		z = abs(z);
		if (z.x<z.y){ z.xy = z.yx;}
		if (z.x< z.z){ z.xz = z.zx;}
		if (z.y<z.z){ z.yz = z.zy;}
		if (z.z<1./3.*Offset.z){ z.z -=2.*( z.z-1./3.*Offset.z);}
		r = dot(z-Offset, z-Offset);
if (n<ColorIterations) orbitTrap = min(orbitTrap, abs(vec4(z.xyz,dot(z,z))));
		n++;
	}
	//return (length(z)-sqrt(3.) ) * pow(Scale, float(-n));
	return(Use_Floor)? min(p,float(z.x-Offset) * pow(Scale, float(-n))):float(z.x-Offset) * pow(Scale, float(-n));
}





















#preset default
FOV = 0.4
Eye = -2.69166,-4.32814,0.965028
Target = 2.62222,4.14272,0.879917
Up = 0.0112236,0.00316913,0.999932
EquiRectangular = false
FocalPlane = 2.22825
Aperture = 0
ApertureNbrSides = 4
ApertureRot = 0
ApStarShaped = false
BokehCircle = 1.7
Gamma = 1.1
ToneMapping = 2
Exposure = 1.5
Brightness = 1
Contrast = 1.2
Saturation = 1
GaussianWeight = 1
AntiAliasScale = 2
RayBounces = 4
RaySteps = 312
FudgeFactor = 1
HitDistance = 1e-05
MaxDepth = 32
Mat_Color = 0.247059,0.247059,0.247059
Mat_Refl = 0.5
Mat_ReflExp = 0.92683
UseTexture = false
DeTex = 
DeTexScale = 0.2439
DeTexExposure = 0.14706
OrbitStrength = 0
X = 1,0.584314,0,-0.56862 Locked
Y = 0.113725,0,1,1 Locked
Z = 1,0.584314,0,0.09804 Locked
R = 1,1,1,-0.0099 Locked
CycleColors = false Locked
Cycles = 3.47327 Locked
SpotLight = 1,0.733333,0.576471,3
SpotLightDir = 0.4074,-0.77778
SpotSize = 3.125
SpotExp = 6.59807
BgColor = 0.686275,0.85098,1,1.2
Ambience = 5
Fog = 0.264
GRIter = 0
GRPower = 0
Iterations = 8
Scale = 2.57628
Offset = 2.75892,0,0.72321
Use_Floor = true
ColorIterations = 3
Mat_SpecExp = 53.1194
Mat_Spec = 1.5
#endpreset

